
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux内存管理 【转】 / 憋错料</title>

    <meta name="description" content="Linux内存管理 【转】 转自:http://blog.chinaunix.net/uid-25909619-id-4491368.html Linux内存管理 摘要:本章首先以应用程序开发者的角度审视Linux的进程内存管理,在此基础上逐步深入到内核中讨论系统物理内存管理和内核内存的使用方法.力求从外到内.水到渠成地引导网友分析Linux的内存管理与使用.在本章最后,我们给出一个内存映射的实例,帮助网友们理解内核内存管理与用户内存管理之间的关系,希望大家最终能驾驭Linux内存管理. 前言 内存管理一向是所有操作系统书">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux内存管理 【转】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>转自：<a href="http://blog.chinaunix.net/uid-25909619-id-4491368.html" rel="external nofollow noreferrer">http://blog.chinaunix.net/uid-25909619-id-4491368.html</a></h1>
<h1>Linux内存管理</h1>
<p><strong>摘要</strong>：本章首先以应用程序开发者的角度审视Linux的进程内存管理，在此基础上逐步深入到内核中讨论系统物理内存管理和内核内存的使用方法。力求从外到内、水到渠成地引导网友分析Linux的内存管理与使用。在本章最后，我们给出一个内存映射的实例，帮助网友们理解内核内存管理与用户内存管理之间的关系，希望大家最终能驾驭Linux内存管理。</p>
<h2>前言</h2>
<p>内存管理一向是所有操作系统书籍不惜笔墨重点讨论的内容，无论市面上或是网上都充斥着大量涉及内存管理的教材和资料。因此，我们这里所要写的Linux内存管理采取避重就轻的策略，从理论层面就不去班门弄斧，贻笑大方了。我们最想做的和可能做到的是从开发者的角度谈谈对内存管理的理解，最终目的是把我们在内核开发中使用内存的经验和对Linux内存管理的认识与大家共享。</p>
<p>当然，这其中我们也会涉及到一些诸如段页等内存管理的基本理论，但我们的目的不是为了强调理论，而是为了指导理解开发中的实践，所以仅仅点到为止，不做深究。</p>
<p>遵循&ldquo;理论来源于实践&rdquo;的&ldquo;教条&rdquo;，我们先不必一下子就钻入内核里去看系统内存到底是如何管理，那样往往会让你陷入似懂非懂的窘境（我当年就犯了这个错误！）。所以最好的方式是先从外部（用户编程范畴）来观察进程如何使用内存，等到大家对内存的使用有了较直观的认识后，再深入到内核中去学习内存如何被管理等理论知识。最后再通过一个实例编程将所讲内容融会贯通。</p>
<h2>进程与内存</h2>
<h3>进程如何使用内存？</h3>
<p>毫无疑问，所有进程（执行的程序）都必须占用一定数量的内存，它或是用来存放从磁盘载入的程序代码，或是存放取自用户输入的数据等等。不过进程对这些内存的管理方式因内存用途不一而不尽相同，有些内存是事先静态分配和统一回收的，而有些却是按需要动态分配和回收的。</p>
<p>对任何一个普通进程来讲，它都会涉及到5种不同的数据段。稍有编程知识的朋友都能想到这几个数据段中包含有&ldquo;程序代码段&rdquo;、&ldquo;程序数据段&rdquo;、&ldquo;程序堆栈段&rdquo;等。不错，这几种数据段都在其中，但除了以上几种数据段之外，进程还另外包含两种数据段。下面我们来简单归纳一下进程对应的内存空间中所包含的5种不同的数据区。</p>
<p><strong><em>代码段</em></strong>：代码段是用来存放可执行文件的操作指令，也就是说是它是可执行程序在内存中的镜像。代码段需要防止在运行时被非法修改，所以只准许读取操作，而不允许写入（修改）操作&mdash;&mdash;它是不可写的。</p>
<p><strong><em>数据段</em></strong>：数据段用来存放可执行文件中已初始化全局变量，换句话说就是存放程序静态分配<a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftn1" rel="external nofollow noreferrer">[1]</a>的变量和全局变量。</p>
<p><strong><em>BSS</em></strong><strong><em>段<a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftn2" rel="external nofollow noreferrer"><strong>[2]</strong></a></em></strong>：BSS段包含了程序中未初始化的全局变量，在内存中&nbsp;bss段全部置零。</p>
<p><strong><em>堆（heap</em></strong><strong><em>）</em></strong>：堆是用于存放进程运行中被动态分配的内存段，它的大小并不固定，可动态扩张或缩减。当进程调用malloc等函数分配内存时，新分配的内存就被动态添加到堆上（堆被扩张）；当利用free等函数释放内存时，被释放的内存从堆中被剔除（堆被缩减）</p>
<p><strong><em>栈</em></strong>：栈是用户存放程序临时创建的局部变量，也就是说我们函数括弧&ldquo;{}&rdquo;中定义的变量（但不包括static声明的变量，static意味着在数据段中存放变量）。除此以外，在函数被调用时，其参数也会被压入发起调用的进程栈中，并且待到调用结束后，函数的返回值也会被存放回栈中。由于栈的先进先出特点，所以栈特别方便用来保存/恢复调用现场。从这个意义上讲，我们可以把堆栈看成一个寄存、交换临时数据的内存区。</p>
<h3>进程如何组织这些区域？</h3>
<p>上述几种内存区域中数据段、BSS和堆通常是被连续存储的&mdash;&mdash;内存位置上是连续的，而代码段和栈往往会被独立存放。有趣的是，堆和栈两个区域关系很&ldquo;暧昧&rdquo;，他们一个向下&ldquo;长&rdquo;（i386体系结构中栈向下、堆向上），一个向上&ldquo;长&rdquo;，相对而生。但你不必担心他们会碰头，因为他们之间间隔很大（到底大到多少，你可以从下面的例子程序计算一下），绝少有机会能碰到一起。</p>
<p>下图简要描述了进程内存区域的分布：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAwMS5naWY=.jpg" /></p>
<p>&ldquo;事实胜于雄辩&rdquo;，我们用一个小例子（原形取自《User-Level Memory Management》）来展示上面所讲的各种内存区的差别与位置。</p>
<p><em>#include&lt;stdio.h&gt;</em></p>
<p><em>#include&lt;malloc.h&gt;</em></p>
<p><em>#include&lt;unistd.h&gt;</em></p>
<p><em>int</em><em>&nbsp;bss_var;</em></p>
<p><em>int</em><em>&nbsp;data_var0=1;</em></p>
<p><em>int</em><em>&nbsp;main(int&nbsp;argc,char&nbsp;**argv)</em></p>
<p><em>{</em></p>
<p><em>&nbsp;&nbsp;printf("below are addresses of types of process‘s&nbsp;mem\n");</em></p>
<p><em>&nbsp;&nbsp;printf("Text location:\n");</em></p>
<p><em>&nbsp;&nbsp;printf("\tAddress&nbsp;of main(Code Segment):%p\n",main);</em></p>
<p><em>&nbsp;&nbsp;printf("____________________________\n");</em></p>
<p><em>&nbsp;&nbsp;int&nbsp;stack_var0=2;</em></p>
<p><em>&nbsp;&nbsp;printf("Stack Location:\n");</em></p>
<p><em>&nbsp;&nbsp;printf("\tInitial&nbsp;end of stack:%p\n",&amp;stack_var0);</em></p>
<p><em>&nbsp;&nbsp;int&nbsp;stack_var1=3;</em></p>
<p><em>&nbsp;&nbsp;printf("\tnew&nbsp;end of stack:%p\n",&amp;stack_var1);</em></p>
<p><em>&nbsp;&nbsp;printf("____________________________\n");</em></p>
<p><em>&nbsp;&nbsp;printf("Data Location:\n");</em></p>
<p><em>&nbsp;&nbsp;printf("\tAddress&nbsp;of&nbsp;data_var(Data Segment):%p\n",&amp;data_var0);</em></p>
<p><em>&nbsp;&nbsp;static&nbsp;int&nbsp;data_var1=4;</em></p>
<p><em>&nbsp;&nbsp;printf("\tNew&nbsp;end of&nbsp;data_var(Data Segment):%p\n",&amp;data_var1);</em></p>
<p><em>&nbsp;&nbsp;printf("____________________________\n");</em></p>
<p><em>&nbsp;&nbsp;printf("BSS Location:\n");</em></p>
<p>printf("\tAddress&nbsp;of&nbsp;bss_var:%p\n",&amp;bss_var);</p>
<p>printf("____________________________\n");</p>
<p>char&nbsp;*b =&nbsp;sbrk((ptrdiff_t)0);</p>
<p>printf("Heap Location:\n");</p>
<p>printf("\tInitial&nbsp;end of&nbsp;heap:%p\n",b);</p>
<p>brk(b+4);</p>
<p>b=sbrk((ptrdiff_t)0);</p>
<p>printf("\tNew&nbsp;end of&nbsp;heap:%p\n",b);</p>
<p>return&nbsp;0;</p>
<p>}</p>
<p>它的结果如下</p>
<p>below&nbsp;are addresses of types of process‘s&nbsp;mem</p>
<p>Text location:</p>
<p>Address of&nbsp;main(Code Segment):0x8048388</p>
<p>____________________________</p>
<p>Stack Location:</p>
<p>Initial end of stack:0xbffffab4</p>
<p>new&nbsp;end of stack:0xbffffab0</p>
<p>____________________________</p>
<p>Data Location:</p>
<p>Address of&nbsp;data_var(Data Segment):0x8049758</p>
<p>New end of&nbsp;data_var(Data Segment):0x804975c</p>
<p>____________________________</p>
<p>BSS Location:</p>
<p>Address of bss_var:0x8049864</p>
<p>____________________________</p>
<p>Heap Location:</p>
<p>Initial end of heap:0x8049868</p>
<p>New end of heap:0x804986c</p>
<p>利用size命令也可以看到程序的各段大小，比如执行size example会得到</p>
<p>text&nbsp;data&nbsp;bss&nbsp;dec&nbsp;hex filename</p>
<p>1654 280&nbsp;&nbsp;&nbsp;8 1942 796 example</p>
<p>但这些数据是程序编译的静态统计，而上面显示的是进程运行时的动态值，但两者是对应的。</p>
<p>通过前面的例子，我们对进程使用的逻辑内存分布已先睹为快。这部分我们就继续进入操作系统内核看看，进程对内存具体是如何进行分配和管理的。</p>
<p>从用户向内核看，所使用的内存表象形式会依次经历&ldquo;逻辑地址&rdquo;&mdash;&mdash;&ldquo;线性地址&rdquo;&mdash;&mdash;&ldquo;物理地址&rdquo;几种形式（关于几种地址的解释在前面已经讲述了）。逻辑地址经段机制转化成线性地址；线性地址又经过页机制转化为物理地址。（但是我们要知道Linux系统虽然保留了段机制，但是将所有程序的段地址都定死为0-4G，所以虽然逻辑地址和线性地址是两种不同的地址空间，但在Linux中逻辑地址就等于线性地址，它们的值是一样的）。沿着这条线索，我们所研究的主要问题也就集中在下面几个问题。</p>
<p>1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;进程空间地址如何管理？</p>
<p>2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;进程地址如何映射到物理内存？</p>
<p>3.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;物理内存如何被管理？</p>
<p>以及由上述问题引发的一些子问题。如系统虚拟地址分布；内存分配接口；连续内存分配与非连续内存分配等。</p>
<h2>进程内存空间</h2>
<p>Linux操作系统采用虚拟内存管理技术，使得每个进程都有各自互不干涉的进程地址空间。该空间是块大小为4G的线性虚拟空间，用户所看到和接触到的都是该虚拟地址，无法看到实际的物理内存地址。利用这种虚拟地址不但能起到保护操作系统的效果（用户不能直接访问物理内存），而且更重要的是，用户程序可使用比实际物理内存更大的地址空间（具体的原因请看硬件基础部分）。</p>
<p>在讨论进程空间细节前，这里先要澄清下面几个问题：</p>
<p>l&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;第一、4G的进程地址空间被人为的分为两个部分&mdash;&mdash;用户空间与内核空间。用户空间从0到3G（0xC0000000），内核空间占据3G到4G。用户进程通常情况下只能访问用户空间的虚拟地址，不能访问内核空间虚拟地址。只有用户进程进行系统调用（代表用户进程在内核态执行）等时刻可以访问到内核空间。</p>
<p>l&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;第二、用户空间对应进程，所以每当进程切换，用户空间就会跟着变化；而内核空间是由内核负责映射，它并不会跟着进程改变，是固定的。内核空间地址有自己对应的页表（init_mm.pgd），用户进程各自有不同的页表。</p>
<p>l&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;第三、每个进程的用户空间都是完全独立、互不相干的。不信的话，你可以把上面的程序同时运行10次（当然为了同时运行，让它们在返回前一同睡眠100秒吧），你会看到10个进程占用的线性地址一模一样。</p>
<h3>进程内存管理</h3>
<p>进程内存管理的对象是进程线性地址空间上的内存镜像，这些内存镜像其实就是进程使用的虚拟内存区域（memory region）。进程虚拟空间是个32或64位的&ldquo;平坦&rdquo;（独立的连续区间）地址空间（空间的具体大小取决于体系结构）。要统一管理这么大的平坦空间可绝非易事，为了方便管理，虚拟空间被划分为许多大小可变的(但必须是4096的倍数)内存区域，这些区域在进程线性地址中像停车位一样有序排列。这些区域的划分原则是&ldquo;将访问属性一致的地址空间存放在一起&rdquo;，所谓访问属性在这里无非指的是&ldquo;可读、可写、可执行等&rdquo;。</p>
<p>如果你要查看某个进程占用的内存区域，可以使用命令cat /proc/&lt;pid&gt;/maps获得（pid是进程号，你可以运行上面我们给出的例子&mdash;&mdash;./example &amp;;pid便会打印到屏幕），你可以发现很多类似于下面的数字信息。</p>
<p>由于程序example使用了动态库，所以除了example本身使用的的内存区域外，还会包含那些动态库使用的内存区域（区域顺序是：代码段、数据段、bss段）。</p>
<p>我们下面只抽出和example有关的信息，除了前两行代表的代码段和数据段外，最后一行是进程使用的栈空间。</p>
<p>-------------------------------------------------------------------------------</p>
<p>08048000 - 08049000 r-xp&nbsp;00000000&nbsp;03:03&nbsp;439029&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/home/mm/src/example</p>
<p>08049000 - 0804a000&nbsp;rw-p 00000000&nbsp;03:03&nbsp;439029&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/home/mm/src/example</p>
<p>&hellip;&hellip;&hellip;&hellip;&hellip;</p>
<p>bfffe000 - c0000000&nbsp;rwxp&nbsp;ffff000&nbsp;00:00&nbsp;0</p>
<p>----------------------------------------------------------------------------------------------------------------------</p>
<p>每行数据格式如下：</p>
<p>（内存区域）开始－结束 访问权限&nbsp;&nbsp;偏移&nbsp;&nbsp;主设备号：次设备号&nbsp;i节点&nbsp;&nbsp;文件。</p>
<p>注意，你一定会发现进程空间只包含三个内存区域，似乎没有上面所提到的堆、bss等，其实并非如此，程序内存段和进程地址空间中的内存区域是种模糊对应，也就是说，堆、bss、数据段（初始化过的）都在进程空间中由数据段内存区域表示。</p>
<p>在Linux内核中对应进程内存区域的数据结构是:&nbsp;vm_area_struct,&nbsp;内核将每个内存区域作为一个单独的内存对象管理，相应的操作也都一致。采用面向对象方法使VMA结构体可以代表多种类型的内存区域－－比如内存映射文件或进程的用户空间栈等，对这些区域的操作也都不尽相同。</p>
<p>vm_area_strcut结构比较复杂，关于它的详细结构请参阅相关资料。我们这里只对它的组织方法做一点补充说明。vm_area_struct是描述进程地址空间的基本管理单元，对于一个进程来说往往需要多个内存区域来描述它的虚拟空间，如何关联这些不同的内存区域呢？大家可能都会想到使用链表，的确vm_area_struct结构确实是以链表形式链接，不过为了方便查找，内核又以红黑树（以前的内核使用平衡树）的形式组织内存区域，以便降低搜索耗时。并存的两种组织形式，并非冗余：链表用于需要遍历全部节点的时候用，而红黑树适用于在地址空间中定位特定内存区域的时候。内核为了内存区域上的各种不同操作都能获得高性能，所以同时使用了这两种数据结构。</p>
<p>下图反映了进程地址空间的管理模型：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAwNC5naWY=.jpg" /></p>
<p>进程的地址空间对应的描述结构是&ldquo;内存描述符结构&rdquo;,它表示进程的全部地址空间，&mdash;&mdash;包含了和进程地址空间有关的全部信息，其中当然包含进程的内存区域。</p>
<h3>进程内存的分配与回收</h3>
<p>创建进程fork()、程序载入execve()、映射文件mmap()、动态内存分配malloc()/brk()等进程相关操作都需要分配内存给进程。不过这时进程申请和获得的还不是实际内存，而是虚拟内存，准确的说是&ldquo;内存区域&rdquo;。进程对内存区域的分配最终都会归结到do_mmap（）函数上来（brk调用被单独以系统调用实现，不用do_mmap()），</p>
<p>内核使用do_mmap()函数创建一个新的线性地址区间。但是说该函数创建了一个新VMA并不非常准确，因为如果创建的地址区间和一个已经存在的地址区间相邻，并且它们具有相同的访问权限的话，那么两个区间将合并为一个。如果不能合并，那么就确实需要创建一个新的VMA了。但无论哪种情况，&nbsp;do_mmap()函数都会将一个地址区间加入到进程的地址空间中－－无论是扩展已存在的内存区域还是创建一个新的区域。</p>
<p>同样，释放一个内存区域应使用函数do_ummap()，它会销毁对应的内存区域。</p>
<h3>如何由虚变实！</h3>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;</strong>从上面已经看到进程所能直接操作的地址都为虚拟地址。当进程需要内存时，从内核获得的仅仅是虚拟的内存区域，而不是实际的物理地址，进程并没有获得物理内存（物理页面&mdash;&mdash;页的概念请大家参考硬件基础一章），获得的仅仅是对一个新的线性地址区间的使用权。实际的物理内存只有当进程真的去访问新获取的虚拟地址时，才会由&ldquo;请求页机制&rdquo;产生&ldquo;缺页&rdquo;异常，从而进入分配实际页面的例程。</p>
<p>该异常是虚拟内存机制赖以存在的基本保证&mdash;&mdash;它会告诉内核去真正为进程分配物理页，并建立对应的页表，这之后虚拟地址才实实在在地映射到了系统的物理内存上。（当然，如果页被换出到磁盘，也会产生缺页异常，不过这时不用再建立页表了）</p>
<p>这种请求页机制把页面的分配推迟到不能再推迟为止，并不急于把所有的事情都一次做完（这种思想有点像设计模式中的代理模式（proxy））。之所以能这么做是利用了内存访问的&ldquo;局部性原理&rdquo;，请求页带来的好处是节约了空闲内存，提高了系统的吞吐率。要想更清楚地了解请求页机制，可以看看《深入理解linux内核》一书。</p>
<p>这里我们需要说明在内存区域结构上的nopage操作。当访问的进程虚拟内存并未真正分配页面时，该操作便被调用来分配实际的物理页，并为该页建立页表项。在最后的例子中我们会演示如何使用该方法。</p>
<h2>系统物理内存管理</h2>
<p>虽然应用程序操作的对象是映射到物理内存之上的虚拟内存，但是处理器直接操作的却是物理内存。所以当应用程序访问一个虚拟地址时，首先必须将虚拟地址转化成物理地址，然后处理器才能解析地址访问请求。地址的转换工作需要通过查询页表才能完成，概括地讲，地址转换需要将虚拟地址分段，使每段虚地址都作为一个索引指向页表，而页表项则指向下一级别的页表或者指向最终的物理页面。</p>
<p>每个进程都有自己的页表。进程描述符的pgd域指向的就是进程的页全局目录。下面我们借用《linux设备驱动程序》中的一幅图大致看看进程地址空间到物理页之间的转换关系。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAwMy5qcGc=.jpg" /></p>
<p>上面的过程说起来简单，做起来难呀。因为在虚拟地址映射到页之前必须先分配物理页&mdash;&mdash;也就是说必须先从内核中获取空闲页，并建立页表。下面我们介绍一下内核管理物理内存的机制。</p>
<h3>物理内存管理（页管理）</h3>
<p>Linux内核管理物理内存是通过分页机制实现的，它将整个内存划分成无数个4k（在i386体系结构中）大小的页，从而分配和回收内存的基本单位便是内存页了。利用分页管理有助于灵活分配内存地址，因为分配时不必要求必须有大块的连续内存<a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftn3" rel="external nofollow noreferrer">[3]</a>，系统可以东一页、西一页的凑出所需要的内存供进程使用。虽然如此，但是实际上系统使用内存时还是倾向于分配连续的内存块，因为分配连续内存时，页表不需要更改，因此能降低TLB的刷新率（频繁刷新会在很大程度上降低访问速度）。</p>
<p>鉴于上述需求，内核分配物理页面时为了尽量减少不连续情况，采用了&ldquo;伙伴&rdquo;关系来管理空闲页面。伙伴关系分配算法大家应该不陌生&mdash;&mdash;几乎所有操作系统方面的书都会提到,我们不去详细说它了，如果不明白可以参看有关资料。这里只需要大家明白Linux中空闲页面的组织和管理利用了伙伴关系，因此空闲页面分配时也需要遵循伙伴关系，最小单位只能是2的幂倍页面大小。内核中分配空闲页面的基本函数是get_free_page/get_free_pages，它们或是分配单页或是分配指定的页面（2、4、8&hellip;512页）。</p>
<p>注意：get_free_page是在内核中分配内存，不同于malloc在用户空间中分配，malloc利用堆动态分配，实际上是调用brk()系统调用，该调用的作用是扩大或缩小进程堆空间（它会修改进程的brk域）。如果现有的内存区域不够容纳堆空间，则会以页面大小的倍数为单位，扩张或收缩对应的内存区域，但brk值并非以页面大小为倍数修改，而是按实际请求修改。因此Malloc在用户空间分配内存可以以字节为单位分配,但内核在内部仍然会是以页为单位分配的。</p>
<p>另外,需要提及的是，物理页在系统中由页结构struct&nbsp;page描述，系统中所有的页面都存储在数组mem_map[]中，可以通过该数组找到系统中的每一页（空闲或非空闲）。而其中的空闲页面则可由上述提到的以伙伴关系组织的空闲页链表（free_area[MAX_ORDER]）来索引。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAwNi5naWY=.jpg" /></p>
<h3>内核内存使用</h3>
<p><strong>Slab</strong></p>
<p>所谓尺有所长，寸有所短。以页为最小单位分配内存对于内核管理系统中的物理内存来说的确比较方便，但内核自身最常使用的内存却往往是很小（远远小于一页）的内存块&mdash;&mdash;比如存放文件描述符、进程描述符、虚拟内存区域描述符等行为所需的内存都不足一页。这些用来存放描述符的内存相比页面而言，就好比是面包屑与面包。一个整页中可以聚集多个这些小块内存；而且这些小块内存块也和面包屑一样频繁地生成/销毁。</p>
<p>为了满足内核对这种小内存块的需要，Linux系统采用了一种被称为slab分配器的技术。Slab分配器的实现相当复杂，但原理不难，其核心思想就是&ldquo;存储池<a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftn4" rel="external nofollow noreferrer">[4]</a>&rdquo;的运用。内存片段（小块内存）被看作对象，当被使用完后，并不直接释放而是被缓存到&ldquo;存储池&rdquo;里，留做下次使用，这无疑避免了频繁创建与销毁对象所带来的额外负载。</p>
<p>Slab技术不但避免了内存内部分片（下文将解释）带来的不便（引入Slab分配器的主要目的是为了减少对伙伴系统分配算法的调用次数&mdash;&mdash;频繁分配和回收必然会导致内存碎片&mdash;&mdash;难以找到大块连续的可用内存），而且可以很好地利用硬件缓存提高访问速度。</p>
<p>Slab并非是脱离伙伴关系而独立存在的一种内存分配方式，slab仍然是建立在页面基础之上，换句话说，Slab将页面（来自于伙伴关系管理的空闲页面链表）撕碎成众多小内存块以供分配，slab中的对象分配和销毁使用kmem_cache_alloc与kmem_cache_free。</p>
<p><strong>Kmalloc</strong></p>
<p>Slab分配器不仅仅只用来存放内核专用的结构体，它还被用来处理内核对小块内存的请求。当然鉴于Slab分配器的特点，一般来说内核程序中对小于一页的小块内存的请求才通过Slab分配器提供的接口Kmalloc来完成（虽然它可分配32&nbsp;到131072字节的内存）。从内核内存分配的角度来讲，kmalloc可被看成是get_free_page（s）的一个有效补充，内存分配粒度更灵活了。</p>
<p>有兴趣的话，可以到/proc/slabinfo中找到内核执行现场使用的各种slab信息统计，其中你会看到系统中所有slab的使用信息。从信息中可以看到系统中除了专用结构体使用的slab外，还存在大量为Kmalloc而准备的Slab（其中有些为dma准备的）。</p>
<p><strong>内核非连续内存分配（</strong><strong>Vmalloc</strong><strong>）</strong></p>
<p><strong>&nbsp;</strong></p>
<p>伙伴关系也好、slab技术也好，从内存管理理论角度而言目的基本是一致的，它们都是为了防止&ldquo;分片&rdquo;，不过分片又分为外部分片和内部分片之说，所谓内部分片是说系统为了满足一小段内存区（连续）的需要，不得不分配了一大区域连续内存给它，从而造成了空间浪费；外部分片是指系统虽有足够的内存，但却是分散的碎片，无法满足对大块&ldquo;连续内存&rdquo;的需求。无论何种分片都是系统有效利用内存的障碍。slab分配器使得一个页面内包含的众多小块内存可独立被分配使用，避免了内部分片，节约了空闲内存。伙伴关系把内存块按大小分组管理，一定程度上减轻了外部分片的危害，因为页框分配不在盲目，而是按照大小依次有序进行，不过伙伴关系只是减轻了外部分片，但并未彻底消除。你自己比划一下多次分配页面后，空闲内存的剩余情况吧。</p>
<p>所以避免外部分片的最终思路还是落到了如何利用不连续的内存块组合成&ldquo;看起来很大的内存块&rdquo;&mdash;&mdash;这里的情况很类似于用户空间分配虚拟内存，内存逻辑上连续，其实映射到并不一定连续的物理内存上。Linux内核借用了这个技术，允许内核程序在内核地址空间中分配虚拟地址，同样也利用页表（内核页表）将虚拟地址映射到分散的内存页上。以此完美地解决了内核内存使用中的外部分片问题。内核提供vmalloc函数分配内核虚拟内存，该函数不同于kmalloc，它可以分配较Kmalloc大得多的内存空间（可远大于128K，但必须是页大小的倍数），但相比Kmalloc来说,Vmalloc需要对内核虚拟地址进行重映射，必须更新内核页表，因此分配效率上要低一些（用空间换时间）</p>
<p>与用户进程相似,内核也有一个名为init_mm的mm_strcut结构来描述内核地址空间，其中页表项pdg=swapper_pg_dir包含了系统内核空间（3G-4G）的映射关系。因此vmalloc分配内核虚拟地址必须更新内核页表，而kmalloc或get_free_page由于分配的连续内存，所以不需要更新内核页表。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAxNS5naWY=.jpg" /></p>
<p>vmalloc分配的内核虚拟内存与kmalloc/get_free_page分配的内核虚拟内存位于不同的区间，不会重叠。因为内核虚拟空间被分区管理，各司其职。进程空间地址分布从０到３G(其实是到PAGE_OFFSET,在0x86中它等于0xC0000000)，从3G到vmalloc_start这段地址是物理内存映射区域（该区域中包含了内核镜像、物理页面表mem_map等等）比如我使用的系统内存是64M(可以用free看到)，那么(3G&mdash;&mdash;3G+64M)这片内存就应该映射到物理内存，而vmalloc_start位置应在3G+64M附近（说"附近"因为是在物理内存映射区与vmalloc_start期间还会存在一个8M大小的gap来防止跃界）,vmalloc_end的位置接近4G(说"接近"是因为最后位置系统会保留一片128k大小的区域用于专用页面映射，还有可能会有高端内存映射区，这些都是细节，这里我们不做纠缠)。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAxMS5naWY=.jpg" /></p>
<p>上图是内存分布的模糊轮廓</p>
<p>　&nbsp;&nbsp;由get_free_page或Kmalloc函数所分配的连续内存都陷于物理映射区域，所以它们返回的内核虚拟地址和实际物理地址仅仅是相差一个偏移量（PAGE_OFFSET），你可以很方便的将其转化为物理内存地址，同时内核也提供了virt_to_phys（）函数将内核虚拟空间中的物理映射区地址转化为物理地址。要知道，物理内存映射区中的地址与内核页表是有序对应的，系统中的每个物理页面都可以找到它对应的内核虚拟地址（在物理内存映射区中的）。</p>
<p>而vmalloc分配的地址则限于vmalloc_start与vmalloc_end之间。每一块vmalloc分配的内核虚拟内存都对应一个vm_struct结构体（可别和vm_area_struct搞混，那可是进程虚拟内存区域的结构），不同的内核虚拟地址被4k大小的空闲区间隔，以防止越界&mdash;&mdash;见下图）。与进程虚拟地址的特性一样，这些虚拟地址与物理内存没有简单的位移关系，必须通过内核页表才可转换为物理地址或物理页。它们有可能尚未被映射，在发生缺页时才真正分配物理页面。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAxMy5qcGc=.jpg" /></p>
<p>这里给出一个小程序帮助大家认清上面几种分配函数所对应的区域。</p>
<p>#include&lt;linux/module.h&gt;</p>
<p>#include&lt;linux/slab.h&gt;</p>
<p>#include&lt;linux/vmalloc.h&gt;</p>
<p>unsigned char *pagemem;</p>
<p>unsigned char *kmallocmem;</p>
<p>unsigned char *vmallocmem;</p>
<p>int&nbsp;init_module(void)</p>
<p>{</p>
<p>pagemem&nbsp;=&nbsp;get_free_page(0);</p>
<p>printk("&lt;1&gt;pagemem=%s",pagemem);</p>
<p>kmallocmem&nbsp;=&nbsp;kmalloc(100,0);</p>
<p>printk("&lt;1&gt;kmallocmem=%s",kmallocmem);</p>
<p>vmallocmem&nbsp;=&nbsp;vmalloc(1000000);</p>
<p>printk("&lt;1&gt;vmallocmem=%s",vmallocmem);</p>
<p>}</p>
<p>void&nbsp;cleanup_module(void)</p>
<p>{</p>
<p>free_page(pagemem);</p>
<p>kfree(kmallocmem);</p>
<p>vfree(vmallocmem);</p>
<p>}</p>
<h2>实例</h2>
<p>内存映射(mmap)是Linux操作系统的一个很大特色，它可以将系统内存映射到一个文件（设备）上，以便可以通过访问文件内容来达到访问内存的目的。这样做的最大好处是提高了内存访问速度，并且可以利用文件系统的接口编程（设备在Linux中作为特殊文件处理）访问内存，降低了开发难度。许多设备驱动程序便是利用内存映射功能将用户空间的一段地址关联到设备内存上，无论何时，只要内存在分配的地址范围内进行读写，实际上就是对设备内存的访问。同时对设备文件的访问也等同于对内存区域的访问，也就是说，通过文件操作接口可以访问内存。Linux中的X服务器就是一个利用内存映射达到直接高速访问视频卡内存的例子。</p>
<p>熟悉文件操作的朋友一定会知道file_operations结构中有mmap方法，在用户执行mmap系统调用时，便会调用该方法来通过文件访问内存&mdash;&mdash;不过在调用文件系统mmap方法前，内核还需要处理分配内存区域（vma_struct）、建立页表等工作。对于具体映射细节不作介绍了，需要强调的是,建立页表可以采用remap_page_range方法一次建立起所有映射区的页表，或利用vma_struct的nopage方法在缺页时现场一页一页的建立页表。第一种方法相比第二种方法简单方便、速度快，&nbsp;但是灵活性不高。一次调用所有页表便定型了，不适用于那些需要现场建立页表的场合&mdash;&mdash;比如映射区需要扩展或下面我们例子中的情况。</p>
<p>我们这里的实例希望利用内存映射，将系统内核中的一部分虚拟内存映射到用户空间，以供应用程序读取&mdash;&mdash;你可利用它进行内核空间到用户空间的大规模信息传输。因此我们将试图写一个虚拟字符设备驱动程序，通过它将系统<strong>内核空间</strong><strong>映射</strong><strong>到用户空间</strong>&mdash;&mdash;将内核虚拟内存映射到用户虚拟地址。从上一节已经看到Linux内核空间中包含两种虚拟地址：一种是物理和逻辑都连续的物理内存映射虚拟地址；另一种是逻辑连续但非物理连续的vmalloc分配的内存虚拟地址。我们的例子程序将演示把vmalloc分配的内核虚拟地址映射到用户地址空间的全过程。</p>
<p>程序里主要应解决两个问题：</p>
<p>第一是如何将vmalloc分配的内核虚拟内存正确地转化成物理地址？</p>
<p>因为内存映射先要获得被映射的物理地址，然后才能将其映射到要求的用户虚拟地址上。我们已经看到内核物理内存映射区域中的地址可以被内核函数virt_to_phys转换成实际的物理内存地址，但对于vmalloc分配的内核虚拟地址无法直接转化成物理地址，所以我们必须对这部分虚拟内存格外&ldquo;照顾&rdquo;&mdash;&mdash;先将其转化成<strong>内核物理内存</strong><strong>映射</strong><strong>区域中的地址，</strong>然后在用virt_to_phys变为物理地址。</p>
<p>转化工作需要进行如下步骤：</p>
<p>a)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;找到vmalloc虚拟内存对应的页表，并寻找到对应的页表项。</p>
<p>b)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;获取页表项对应的页面指针</p>
<p>c)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;通过页面得到对应的内核物理内存映射区域地址<strong>。</strong></p>
<p>如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3Lmtlcm5lbHRyYXZlbC5uZXQvam91cm5hbC92L21lbS5maWxlcy9pbWFnZTAxNi5naWY=.jpg" /></p>
<p>第二是当访问vmalloc分配区时，如果发现虚拟内存尚未被映射到物理页，则需要处理&ldquo;缺页异常&rdquo;。因此需要我们实现内存区域中的nopaga操作，以能返回被映射的物理页面指针，在我们的实例中就是返回上面过程中的内核物理内存映射区域中的地址<strong>。</strong>由于vmalloc分配的虚拟地址与物理地址的对应关系并非分配时就可确定，必须在缺页现场建立页表，因此这里不能使用remap_page_range方法，只能用vma的nopage方法一页一页的建立。</p>
<p><strong>&nbsp;</strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>程序组成</strong></p>
<p>map_driver.c，它是以模块形式加载的虚拟字符驱动程序。该驱动负责将一定长的内核虚拟地址(vmalloc分配的)映射到设备文件上。其中主要的函数有&mdash;&mdash;vaddress_to_kaddress（）负责对vmalloc分配的地址进行页表解析,以找到对应的内核物理映射地址（kmalloc分配的地址）；map_nopage()负责在进程访问一个当前并不存在的VMA页时，寻找该地址对应的物理页，并返回该页的指针。</p>
<p>test.c&nbsp;它利用上述驱动模块对应的设备文件在用户空间读取读取内核内存。结果可以看到内核虚拟地址的内容（ok!），被显示在了屏幕上。</p>
<p><strong>执行步骤</strong></p>
<p>编译map_driver.c为map_driver.o模块,具体参数见Makefile</p>
<p>加载模块&nbsp;：insmod&nbsp;map_driver.o</p>
<p>生成对应的设备文件</p>
<p>1&nbsp;在/proc/devices下找到map_driver对应的设备命和设备号：grep&nbsp;mapdrv&nbsp;/proc/devices</p>
<p>2&nbsp;建立设备文件mknod&nbsp;&nbsp;mapfile&nbsp;c 254 0&nbsp;&nbsp;（在我的系统里设备号为254）</p>
<p>利用maptest读取mapfile文件，将取自内核的信息打印到屏幕上。</p>
<p>全部程序下载&nbsp;<a href="http://www.kerneltravel.net/journal/v/mmap.tar" rel="external nofollow noreferrer">mmap.tar</a>（感谢Martin Frey，该程序的主体出自他的灵感）</p>
<hr />
<p><a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftnref1" rel="external nofollow noreferrer">[1]</a>&nbsp;静态分配内存就是编译器在编译程序的时候根据源程序来分配内存.&nbsp;动态分配内存就是在程序编译之后,&nbsp;运行时调用运行时刻库函数来分配内存的.&nbsp;静态分配由于是在程序运行之前,所以速度快,&nbsp;效率高,&nbsp;但是局限性大.&nbsp;动态分配在程序运行时执行,所以速度慢,&nbsp;但灵活性高.</p>
<p><a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftnref2" rel="external nofollow noreferrer">[2]</a>术语"BSS"已经有些年头了，它是<em>block started by symbol</em>的缩写。因为未初始化的变量没有对应的值,所以并不需要存储在可执行对象中。但是因为C标准强制规定未初始化的全局变量要被赋予特殊的默认值(基本上是0值)，所以内核要从可执行代码装入变量(未赋值的)到内存中，然后将零页映射到该片内存上，于是这些未初始化变量就被赋予了0值。这样做避免了在目标文件中进行显式地初始化，减少空间浪费（来自《Linux内核开发》）</p>
<p><a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftnref3" rel="external nofollow noreferrer">[3]</a>&nbsp;还有些情况必须要求内存连续，比如DMA传输中使用的内存，由于不涉及页机制所以必须连续分配。</p>
<p><a href="http://www.kerneltravel.net/journal/v/mem.htm#_ftnref4" rel="external nofollow noreferrer">[4]</a>&nbsp;这种存储池的思想在计算机科学里广泛应用，比如数据库连接池、内存访问池等等。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 14:48:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux内存管理 【转】的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/bMoY2k3.html" rel="bookmark">linux内存管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Linux 进程在内存中的数据结构 一个可执行程序在存储(没有调入内存)时分为代码段,数据段,未初始化数据段三部分:    1) 代码段:存放CPU执行的机器指令.通常代码区是共享的,即其它执行程序可调用它.假如机器中有数个进程运行相同的一个程序,那么它们就可以使用同一个代码段.     2) 数据段:存放已初始化的全局变量.静态变量(包括全局和局部的).常量.static全局变量和static函数只能在当前文件中被调用.     3) 未初始化数据区(uninitializeddata s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMykZn3.html" rel="bookmark">Linux内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.首先大概了解一下计算机CPU.Cache.内存.硬盘之间的关系及区别. 1.  CPU也称为中央处理器(CPU,Central Processing Unit)是一块超大规模的集成电路, 是一台计算机的运算核心(Core)和控制核心( Control Unit).它的功能主要是解释计算机指令以及处理计算机软件中的数据.中央处理器主要由三核心部件组成,运算器.控制器和总线(BUS),运算器又主要由算术逻辑单元(ALU)和寄存器(RS)组成. 2.Cache即高速缓冲存储器,是位于CPU与主内存			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLa2p0.html" rel="bookmark">linux内存管理浅析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[地址映射](图:左中)linux内核使用页式内存管理,应用程序给出的内存地址是虚拟地址,它需要经过若干级页表一级一级的变换,才变成真正的物理地址.想一下,地址映射还是一件很恐怖的事情.当访问一个由虚拟地址表示的内存空间时,需要先经过若干次的内存访问,得到每一级页表中用于转换的页表项(页表是存放在内存里面的),才能完成映射.也就是说,要实现一次内存访问,实际上内存被访问了N+1次(N=页表级数),并且还需要做N次加法运算.所以,地址映射必须要有硬件支持,mmu(内存管理单元)就是这个硬件.并且需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVwbRx0.html" rel="bookmark">启动期间的内存管理之初始化过程概述----Linux内存管理&lpar;九&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日期 内核版本 架构 作者 GitHub CSDN 2016-06-14 Linux-4.7 X86 &amp; arm gatieme LinuxDeviceDrivers Linux内存管理 在内存管理的上下文中, 初始化(initialization)可以有多种含义. 在许多CPU上, 必须显式设置适用于Linux内核的内存模型. 例如在x86_32上需要切换到保护模式, 然后内核才能检测到可用内存和寄存器. 而我们今天要讲的boot阶段就是系统初始化阶段使用的内存分配器. 1 前景回顾 1.1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nv5L70.html" rel="bookmark">linux内存管理---物理地址、线性地址、虚拟地址、逻辑地址之间的转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux内存管理---虚拟地址.逻辑地址.线性地址.物理地址的区别(一) 这篇文章中介绍了四个名词的概念,下面针对四个地址的转换进行分析 CPU将一个虚拟内存空间中的地址转换为物理地址,需要进行两步(如下图): 首先,将给定一个逻辑地址(其实是段内偏移量,这个一定要理解!!!),CPU要利用其段式内存管理单元,先将为个逻辑地址转换成一个线程地址, 其次,再利用其页式内存管理单元,转换为最终物理地址. 这样做两次转换,的确是非常麻烦而且没有必要的,因为直接可以把线性地址抽像给进程.之所以这样冗余			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q8GKL3.html" rel="bookmark">Linux内存管理 &lpar;一&rpar; 内存组织</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内存管理是内核最复杂同时也是最重要的一部.其特点在于非常需要处理器和内核之间的协作. 首先内存划分为结点,在内核中表示为pg_data_t,每个结点划分为内存域. 以下的所有数据结构或代码都做了不同程度的精减,一方面是为了保留相关代码,除去细枝末叶,另一方面是为了美观. 结点的数据结构为 &lt;mmzone.h&gt;typedef struct pglist_data { struct zone node_zones[MAX_NR_ZONES]; /*内存结点所包含的内存域数组*/ struct zo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418r9G3.html" rel="bookmark">Linux内存管理1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 关于内存管理的系列文章主要是对陈莉君老师所讲述的内存管理知识的整理. 本文将主要以X86架构来介绍Linux内存管理的相关知识. 2. 内存寻址 内存寻址是操作系统设计的硬件基础之一 操作系统是横跨软件和硬件的桥梁 操作系统设计者必须在硬件相关代码和硬件无关代码之间划分清晰的界限,以便操作系统很容易的移植到不同的平台 内存寻址的不同时期 (1)石器时代---8位寻址:4004是4位寻址,8080是8位寻址,由一个主累加器(寄存器A)和6个次累加器(寄存器B,C,D,E,H和L),没有段			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d5G6g3.html" rel="bookmark">Python学习第六天----Linux内存管理、进程管理、RPM包安装管理及源码安装软件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux内存管理.进程管理.RPM包安装管理及源码安装软件 一.交换分区     交换分区其实就相当于Windows系统下的虚拟内存的概念,当物理内存不够用的时候,由操作系统将硬盘的一块区域划分出来作为内存使用.具体使用方法如下:      [[email protected] ~]# fdisk -l 磁盘 /dev/sdb:16.1 GB, 16106127360 字节,31457280 个扇区 Units = 扇区 of 1 * 512 = 512 bytes 扇区大小(逻辑/物理):5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l5obZ3.html" rel="bookmark">linux内存管理---虚拟地址、逻辑地址、线性地址、物理地址的区别（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分析linux内存管理机制,离不了上述几个概念,在介绍上述几个概念之前,先从&lt;深入理解linux内核&gt;这本书中摘抄几段关于上述名词的解释: 一.&lt;深入理解linux内核&gt;的解释 逻辑地址(Logical Address) 包含在机器语言指令中用来指定一个操作数或一条指令的地址(有点深奥).这种寻址方式在80x86著名的分段结构中表现得尤为具体,它促使windows程序员把程序分成若干段.每个逻辑地址都由一个段和偏移量组成,偏移量指明了从段开始的地方到实际地址之间的距离. 线性地址(			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJRzw4.html" rel="bookmark" class="title">ACM 图像有用区域</a>
					<div>
						图像有用区域 时间限制:3000 ms  |  内存限制:65535 KB 难度:4 描述 “ACKing”同学以前做一个图像处理的项目时,遇到了一个问题,他需要摘取出图片中某个黑色线圏成的区域以内的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8oOk3.html" rel="bookmark" class="title">磁盘挂载与卸载</a>
					<div>
						在挂载某个分区前需要先建立一个挂载点,这个挂载点是以目录的形式出现的.一旦把某个分区挂载到这个目录下,那么再往这个目录里写数据时,则都会写到该分区中.在挂载该分区前,挂载点下最好是个空目录,不为空也不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEk5Ny3.html" rel="bookmark" class="title">LVM2详解</a>
					<div>
						LVM2详解 LVM2详解 大纲: 简介 版本 LVM基本术语 LVM模块 具体操作 对添加的硬盘进行分区( fdisk /dev/[hs]d[a-z] ) 对创建的分区创建物理卷(pvcreate) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRNnKM.html" rel="bookmark" class="title">Java正则表达式实例详解</a>
					<div>
						创建正则表达式 你可以从比较简单的东西入手学习正则表达式.要想全面地掌握怎样构建正则表达式,可以去看JDK 文档的java.util.regex 的Pattern 类的文档. 字符 B 字符B \xh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvlY54.html" rel="bookmark" class="title">机器学习方法（一）：线性回归Linear regression</a>
					<div>
						开一个机器学习方法科普系列,也做基础回顾之用.学而时习之. content: linear regression, Ridge, Lasso Logistic Regression, Softmax  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jnRd90.html" rel="bookmark" class="title">Entity Framework返回IEnumerable还是IQueryable&quest;</a>
					<div>
						在使用EF的过程中,我们常常使用repository模式,本文就在repository层的返回值是IEnumerable类型还是IQueryable进行探讨. 阅读目录: 一.什么是Repositor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/352ymj4.html" rel="bookmark" class="title">《JavaScript高级程序设计 第二版》理解对象</a>
					<div>
						声明:这类属于学习笔记,主要是摘录书中内容,比较少的整理.内容经常是跳跃的,建议您阅读书本,收益更大. ECMA-262把对象定义为“无序属性的集合,其属性可以包含基本值,对象或者函数” 对象时一组没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rwjq93.html" rel="bookmark" class="title">计算器简单封装和ASP&period;net</a>
					<div>
						封装: using System; using System.Collections.Generic; using System.Linq; using System.Text; namespace  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdmvA0.html" rel="bookmark" class="title">用c语言输出菱形（13行）</a>
					<div>
						#include &lt;stdio.h&gt; int main() { int i,j; //先管前7行 for (i=1;i&lt;=7;i++)//for循环内表示的一行的情况 { for(j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rk8aY3.html" rel="bookmark" class="title">Spring源码深度解析第2天</a>
					<div>
						没想到看了一个小时只看了一个方法 spring的StringUtils类中包含了很多字符串处理方法.其中很多方法都和String的方法一个效果.实在不明白为何要自己写一个... BeanFactory ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rZYWM.html" rel="bookmark" class="title">BigDecimal进行除法divide运算注意事项</a>
					<div>
						Java编程中 BigDecimal进行除法divide运算时,如果结果不整除,出现无限循环小数.则会抛出以下异常: java.lang.ArithmeticException: Non-termin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AxEmK3.html" rel="bookmark" class="title">Incorrect password or data is corrupted&period;Would you like to re-log&quest; git改密码之后报错</a>
					<div>
						改了github密码之后,eclipse(sts版本)提交代码的时候,不管怎么输入密码都报错: Incorrect password or data is corrupted.Would you li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a6gAq3.html" rel="bookmark" class="title">移动端Web开发（响应式设计）</a>
					<div>
						Amaze移动端开发框架:http://amazeui.org/ Zepto.js:http://www.css88.com/doc/zeptojs_api/ 移动端下拉刷新插件:https://gi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xADvL3.html" rel="bookmark" class="title">org&period;hibernate&period;PropertyAccessException&colon; Null value was assigned to a property of primitive type setter of 异常</a>
					<div>
						在开发项目的过程中,发现如下异常: 原因是updateType字段为int类型,不能接收null,而在数据库中对应的字段为null,解决方法:将updateType字段类型改为Integer.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdoZa0.html" rel="bookmark" class="title">voj  1754  spfa</a>
					<div>
						最优贸易 最优贸易 描述 C 国有 n 个大城市和 m 条道路,每条道路连接这 n 个城市中的某两个城市.任意两个 城市之间最多只有一条道路直接相连.这 m 条道路中有一部分为单向通行的道路,一部分  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4An1eKM.html" rel="bookmark" class="title">&amp;quot&semi;请求被中止&colon; 未能创建 SSL&sol;TLS 安全通道&amp;quot&semi;解决办法</a>
					<div>
						1.安装证书: 手动双击证书安装,过程略 2.分配权限: 在控制台中找到安装的证书,右键选择“管理私钥”, 添加自己需要的权限,如果在测试可以直接添加Everyone 3.修改代码:public st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnRvYM.html" rel="bookmark" class="title">leetCode102&period; Binary Tree Level Order Traversal 二叉树层次遍历</a>
					<div>
						102. Binary Tree Level Order Traversal Given a binary tree, return the level order traversal of its  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNzyE0.html" rel="bookmark" class="title">jquery  循环php数据</a>
					<div>
						html $.post(&quot;url&quot;,{id:id},function(data){            for(var i=0,l=data.length;i&lt;l;i++) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nbJgv0.html" rel="bookmark" class="title">Android 自定义组件</a>
					<div>
						参考:http://blog.csdn.net/wxg630815/article/details/6989316 http://blog.csdn.net/wxg630815/article/det ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgma2n3.html" rel="bookmark" class="title">数码宅如何玩转黑色星期五？你需要知道这七点</a>
					<div>
						时至年末,各种促销活动接踵而至.这不刚过完双 11 马上就又到了北美的购物季--黑色星期五.尽管黑五和多数国人似乎没什么关系,但近两年来由于电子商务的快速发展以及国内物价上涨,越来越多的国内消费者渐渐 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
